﻿Imports System.Net
Imports System.Threading
Imports System.EventArgs
Imports System.Text



Public Class GotATranslatorClass

    Public Sub New()
        InitializeComponent()
    End Sub


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Start_Threads()
        Me.tsslStatus.Text = "Waiting for input "
        Me.UpdateForm()
    End Sub

    Public Sub UpdateForm()
        RichTextBox1.Visible = Me.chkboxRobotCommunicationsLog.Checked
        Me.tsslStatusCommunications.Text = "Comms: "
        If Bot_Socket.Connected Or ComPort.IsOpen Then Me.tsslStatusCommunications.Text += "Bot "
        If GotABot1ServerClass.Connected Then Me.tsslStatusCommunications.Text += "GotABot "
    End Sub


    Private Sub subMouseMove(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.MouseMove
        UpdateForm()
    End Sub




    Private Sub chkboxRobotCommunicationsLog_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles chkboxRobotCommunicationsLog.CheckedChanged
        UpdateForm()
    End Sub





    '==========================  Resize  ==================================================



    Private Sub Got_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Paint
        RichTextBox1.Width = Me.Width - 40
        RichTextBox1.Height = Me.Height - 150
    End Sub


    Private Sub Zoom_MouseWheel(ByVal sender As System.Object, ByVal e As MouseEventArgs) Handles Me.MouseWheel
        If e.Delta <> 0 Then
            Me.Width += CInt(Me.Width * e.Delta / 1000)
            Me.Height += CInt(Me.Height * e.Delta / 1000)
            If e.Delta <= 0 Then
                If Me.Height < 300 Then Me.Height = 300 '
                If Me.Width < 600 Then Me.Width = 600 '
            Else
                If Me.Height > Screen.PrimaryScreen.Bounds.Height Then Me.Height = Screen.PrimaryScreen.Bounds.Height
                If Me.Width > Screen.PrimaryScreen.Bounds.Width Then Me.Width = Screen.PrimaryScreen.Bounds.Width
            End If
            Got_Resize(sender, e)
            System.Windows.Forms.Application.DoEvents()
            Me.Refresh()
        End If
    End Sub



    '==========================  Show Robot Communications   ==================================================


    Public Sub WriteComms(ByVal colFont As Color, ByVal strtext As String)
        If chkboxRobotCommunicationsLog.Checked Then
            If CBool(InStr(strtext, "vbCr")) Then _
               strtext = strtext.Replace(vbCrLf, "") '  
            RichTextBox1.AppendText(strtext)
            Dim textEnd As Integer = RichTextBox1.TextLength
            Dim lastIndex As Integer = Text.LastIndexOf(RichTextBox1.Text)
            Dim index As Integer = RichTextBox1.TextLength - strtext.Length   'Kludge
            RichTextBox1.Find(strtext, index, textEnd, RichTextBoxFinds.WholeWord)
            RichTextBox1.SelectionColor = colFont
            RichTextBox1.AppendText(vbCrLf)
            RichTextBox1.SelectionStart = RichTextBox1.TextLength       'Scroll
            RichTextBox1.ScrollToCaret()
        End If
    End Sub






    Private Sub me_exit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.FormClosed
    End Sub






    Public Sub subWait(ByVal intMillseconds As Integer)
        Dim TimeEnd As DateTime
        TimeEnd = Now().AddMilliseconds(intMillseconds)
        Do
            Application.DoEvents()
        Loop Until Now() > TimeEnd
        TimeEnd = Nothing
    End Sub






    '==================================== THREADS   =============================================

    Sub Start_Threads()
        evntGotABot1 = New GotABot1ServerClass()
        Dim GotABotThreadObject As New GotABot1ServerClass()
        Dim GotABot1MainThread As New Thread(AddressOf evntGotABot1.Main)
        GotABot1MainThread.IsBackground = True
        GotABot1MainThread.Start()
    End Sub






    '==================================== GotABot  Thread  =============================================
    Dim GotABot1MainThread As Thread
    Delegate Sub DelegateevntGotABot()
    Dim WithEvents evntGotABot1 As GotABot1ServerClass

    Sub evntGotABot_evntGotABotCommandReceived(ByVal boolGotABotCommandReceived As Boolean) Handles evntGotABot1.evntGotABotCommandReceived
        If boolGotABotCommandReceived Then GotABotCommandReceived()
    End Sub


    Sub GotABotCommandReceived()
        ' If InvokeRequired is true then the call is being made on a thread other
        ' than the UI thread.
        On Error Resume Next
        If Me.InvokeRequired And Not boolShutDown Then
            Dim newDelegate As New DelegateevntGotABot(AddressOf GotABotCommandReceived)
            Me.Invoke(newDelegate)
        Else
            GotABotParseAndRespond()
        End If ' Me.InvokeRequired
    End Sub

End Class








